import mongoose from 'mongoose'; 

const Schema = mongoose.Schema

export const EventSchema = new Schema({
    eventTitle: {
        type: String,
        required: true,
        trim: true
    },
    organiser: {
        type: String,
        required: true,
        trim: true
    },
    venueName: {
        type: String,
        required: true,
        trim: true
    },
    venueAddress: {
        type: String,
        required: true,
        trim: true
    },
    eventGenre: {
        type: String,
        required: true
    },
    startDate: {
        type: String,
        required: true
    },
    endDate: {
        type: String,
        required: true
    },
    startTime: {
        type: String, 
        required: true
    },
    endTime: {
        type: String, 
        required: true
    }, 
    ticketPrice: {
        type: String, 
        // required: true
    },
    ticketQty: {
        type: String, 
        // required: true
    },
    eventDescription: {
        type: String,
        required: true
    }, 
    createdDate: {
        type: Date, 
        default: Date.now
    }
})

const Event = mongoose.model('Event', EventSchema);

module.exports = Event 
