import React, { useState, useEffect } from "react";
import EventCard from "../Components/EventCard";
import { getAllEvents } from "../api/events";
import { getAllPurchases } from "../api/purchases";
import { getLocalStorage } from "../Helpers/localStorage";
import Grid from "@mui/material/Grid";
import Typography from "@mui/material/Typography";

const MyTickets = () => {
    
  // List of events taken from DB
  const [allEvents, setAllEvents] = useState([]);

  //User object
  const [user, setUser] = useState(null);

  // Get all events for the list on marketplace
  useEffect(() => {
    setUser(getLocalStorage("user"));
  }, []);

  useEffect(() => {
    if (user !== null) {
      async function getPurchasedEvents() {
        let events = await getAllEvents();
        let purchases = await getAllPurchases();
        purchases = purchases.data;
        events = events.data;

        //List of purchased events to be seen on screen
        let new_events = [];

        if (purchases !== undefined) {
          //Only search through my purchases by filtering to my user id
          purchases = purchases.filter((val) => val.user_id === user._id);

          // Loop through my purchases to get the event linked
          for (let i = 0; i < purchases.length; i++) {
            //Push the event linked to the purchase to the list to be presented
            new_events.push(
              events.find((val) => val._id === purchases[i].event_id)
            );
          }
        }
        setAllEvents(new_events);
      }
      getPurchasedEvents();
    }
  }, [user]);
  return (
    <Grid container spacing={2} sx={{ padding: "50px 80px" }}>
      <>
        <Grid item container xs={12}>
          <Typography variant={"h5"}>My Tickets</Typography>
        </Grid>
        <Grid item container xs={12} spacing={2}>
          {allEvents.map((val) => {
            return (
              <Grid item xs={4}>
                <EventCard
                  eventData={val}
                  type={"small"}
                  setSelectedEvent={() => {}}
                />
              </Grid>
            );
          })}
        </Grid>
      </>
    </Grid>
  );
};

export default MyTickets;
